searchNodes=[{"type":"module","title":"Tempel","doc":"This module is used to manage file attachments. It accept a single or list of file formatted to match file format of Plug.Upload %{ filename :: binary ( ) , path :: Path . t , content_type : binary ( ) } Get Started define your own file uploader defmodule MyUploader do use Temple.Gate def init ( opts ) do # add important configuration here such as storage key and cridentials %{ } end # Define file pipeline # This pipeline will only save the main image, no other variants will be saved @impl true def pipeline ( :product , files , _opts ) do no_variants ( files , [ ] ) end # Define file pipeline with other variants def pipeline ( :avatar , files , opts ) do create_variants ( files , variants : [ avatar : [ operation : :avatar , resize_options : [ size : 100 ] , filename : fn name , _opts -&gt; user_id = Access . get ( opts , :user_id , &quot;&quot; ) &quot;radom&quot; &lt;&gt; &quot;-&quot; &lt;&gt; user_id &lt;&gt; &quot;-&quot; &lt;&gt; name end ] , thumbnail : [ operation : :thumbnail , resize_options : [ size : &quot;300x400&quot; , options : [ fit : :cover ] ] , write_options : [ path : :memory , options : [ suffix : &quot;.jpeg&quot; ] ] , filename : fn name , _opts -&gt; name end ] ] , save_original : true , filename : fn name , _opts -&gt; user_id = Access . get ( opts , :user_id , &quot;&quot; ) &quot;main&quot; &lt;&gt; &quot;-&quot; &lt;&gt; user_id &lt;&gt; &quot;-&quot; &lt;&gt; name end ) end end To call this uploader in you uploading process # file from `Plug.Upload` MyUploader . save ( :avatar , file ) # =&gt; {:ok, %{&quot;main&quot; =&gt; object_key, &quot;thumbnail&quot; =&gt; object_key}} Myuploader . save ( :product , file ) # =&gt; {:ok, %{&quot;main&quot; =&gt; object_key}}","ref":"Tempel.html"},{"type":"behaviour","title":"Tempel.Gate","doc":"Summary Provides functionality to creates uploader modules Examples defmodule MyUploader do use Tempel.Gate def init ( opts \\\\ %{ } ) do # do something to warmup the uploader and return a map opts end @impl true def pipeline ( :profile , files , options ) do create_variants ( files , variants : [ thumbnail : [ operation : :thumbnail , resize_options : [ size : &quot;300x400&quot; , options : [ fit : :cover ] ] , filename : name , _opts -&gt; &quot;thumbnails/&quot; &lt;&gt; options [ :user_id ] &lt;&gt; &quot;/&quot; &lt;&gt; name end ] ] , save_original : true ) end end this uploader is fully functional, cann be invoked from different modules. MyUploader . save ( :profile , file , %{ &quot;user_id&quot; : 10 } ) # =&gt; {:ok, %{&quot;thumbnail&quot;: &quot;thumbnails/10/file.jpg&quot;, &quot;main&quot; =&gt; &quot;file.jpg&quot;}} For files without variants such as document/pdf we can use no_variants/2 defmodule MyUploader do # all other code def pipeline ( :document , files , options ) do no_variants ( files , filename : name , _opts -&gt; &quot;document/&quot; &lt;&gt; options [ &quot;user_id&quot; ] &lt;&gt; &quot;/&quot; &lt;&gt; name end ) end end MyUploader . save ( :document , file , %{ &quot;user_id&quot; : 10 } ) # =&gt; {:ok, %{&quot;main&quot; =&gt; &quot;document/10/file.pdf&quot;}} Available types: file() is structured to match the format of Plug.Upload fileio() is structured like file() . But instead of the file path it contains the IO data in key :iodata","ref":"Tempel.Gate.html"},{"type":"function","title":"Tempel.Gate.create_variants/2","doc":"","ref":"Tempel.Gate.html#create_variants/2"},{"type":"function","title":"Tempel.Gate.format_files/1","doc":"","ref":"Tempel.Gate.html#format_files/1"},{"type":"callback","title":"Tempel.Gate.init/1","doc":"This function is used to initialize the settings, could be storage path, aws secret key, etc.","ref":"Tempel.Gate.html#c:init/1"},{"type":"function","title":"Tempel.Gate.no_variants/2","doc":"","ref":"Tempel.Gate.html#no_variants/2"},{"type":"function","title":"Tempel.Gate.persitance/0","doc":"","ref":"Tempel.Gate.html#persitance/0"},{"type":"callback","title":"Tempel.Gate.pipeline/3","doc":"","ref":"Tempel.Gate.html#c:pipeline/3"},{"type":"function","title":"Tempel.Gate.variant/0","doc":"","ref":"Tempel.Gate.html#variant/0"},{"type":"function","title":"Tempel.Gate.write_option/2","doc":"","ref":"Tempel.Gate.html#write_option/2"},{"type":"type","title":"Tempel.Gate.file/0","doc":"This type is stuctured like the format of Plug.Upload","ref":"Tempel.Gate.html#t:file/0"},{"type":"type","title":"Tempel.Gate.fileio/0","doc":"fileio() is structured like file() . But instead of the file path it contains the IO data in key :iodata mainly the result from variant generation in Tempel.Variant","ref":"Tempel.Gate.html#t:fileio/0"},{"type":"type","title":"Tempel.Gate.raw_variant/0","doc":"This type is the one will be consumed to Tempel.Local","ref":"Tempel.Gate.html#t:raw_variant/0"},{"type":"type","title":"Tempel.Gate.saved_variant/0","doc":"This type is the retun after save from Tempel.Local through Tempel.Persistence","ref":"Tempel.Gate.html#t:saved_variant/0"},{"type":"module","title":"Tempel.Local","doc":"","ref":"Tempel.Local.html"},{"type":"function","title":"Tempel.Local.delete/2","doc":"","ref":"Tempel.Local.html#delete/2"},{"type":"function","title":"Tempel.Local.init/1","doc":"","ref":"Tempel.Local.html#init/1"},{"type":"function","title":"Tempel.Local.save/2","doc":"","ref":"Tempel.Local.html#save/2"},{"type":"function","title":"Tempel.Local.to_url/2","doc":"","ref":"Tempel.Local.html#to_url/2"},{"type":"module","title":"Tempel.Persistence","doc":"","ref":"Tempel.Persistence.html"},{"type":"function","title":"Tempel.Persistence.delete/2","doc":"","ref":"Tempel.Persistence.html#delete/2"},{"type":"function","title":"Tempel.Persistence.init/1","doc":"","ref":"Tempel.Persistence.html#init/1"},{"type":"function","title":"Tempel.Persistence.save/2","doc":"","ref":"Tempel.Persistence.html#save/2"},{"type":"function","title":"Tempel.Persistence.to_url/2","doc":"","ref":"Tempel.Persistence.html#to_url/2"},{"type":"module","title":"Tempel.Variant","doc":"","ref":"Tempel.Variant.html"},{"type":"function","title":"Tempel.Variant.create/2","doc":"Callback implementation for Tempel.VariantBehaviour.create/2 .","ref":"Tempel.Variant.html#create/2"},{"type":"function","title":"Tempel.Variant.resize/3","doc":"","ref":"Tempel.Variant.html#resize/3"},{"type":"function","title":"Tempel.Variant.write/2","doc":"","ref":"Tempel.Variant.html#write/2"},{"type":"behaviour","title":"Tempel.VariantBehaviour","doc":"","ref":"Tempel.VariantBehaviour.html"},{"type":"callback","title":"Tempel.VariantBehaviour.create/2","doc":"","ref":"Tempel.VariantBehaviour.html#c:create/2"},{"type":"extras","title":"Tempel","doc":"TODO: Add description","ref":"readme.html"},{"type":"extras","title":"Tempel - Installation","doc":"If available in Hex , the package can be installed by adding tempel to your list of dependencies in mix.exs : def deps do [ { :tempel , &quot;~&gt; 0.2.1&quot; } ] end Documentation can be generated with ExDoc and published on HexDocs . Once published, the docs can be found at https://hexdocs.pm/tempel .","ref":"readme.html#installation"}]